*+--------------------------------------------------------------------
*+
*+ Source Module => d:\ALASKA\6\\DbeSys.prg
*+
*+    Copyright(C) 1983-2020 by Auge & Ohr
*+
*+    Functions: Procedure dbeSys()
*+
*+    Reformatted by Click! 2.05.30 on Jun-8-2020 at  5:11 am
*+
*+--------------------------------------------------------------------

//////////////////////////////////////////////////////////////////////
//
//  DBESYS.PRG
//
//  Copyright:
//      Alaska Software, (c) 1998-2009. Alle Rechte vorbehalten.
//
//  Inhalt:
//      Xbase++ DatabaseEngine startup/preloader
//
//  Syntax:
//      DbeSys() wird am Anfang des Programms vor der Funktion MAIN
//      automatich aufgerufen.
//
//////////////////////////////////////////////////////////////////////

// Text-Konstanten
#define MSG_DBE_NOT_LOADED   " Database-Engine nicht geladen"
#define MSG_DBE_NOT_CREATED  " Database-Engine;konnte nicht erzeugt werden"

// ******************************************************************************
//  DbeSys() wird bei jedem Programmstart ausgefhrt
// ******************************************************************************

*+--------------------------------------------------------------------
*+
*+    Procedure dbeSys()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE dbeSys()

   /*
 *   Der Parameter lHidden wird fr alle Database-Engines, die zu 
 *   einer abstrakten Database-Engine kombiniert werden, auf .T. gesetzt.
 */
LOCAL aDbes := { { "DBFDBE", .T. }, ;
                    { "NTXDBE", .T. }, ;
                    { "DELDBE", .F. }, ;
                    { "SDFDBE", .F. } }
LOCAL aBuild := { { "DBFNTX", 1, 2 } }
LOCAL i

   /*
   *   Setzen der Sortierfolge und des Datumformates
   */
   SET COLLATION TO GERMAN
   SET DATE TO GERMAN

   /*
   *   Laden aller Database-Engines
   */
   FOR i := 1 TO LEN( aDbes )
      IF !DbeLoad( aDbes[ i ] [ 1 ], aDbes[ i ] [ 2 ] )
         ALERT( aDbes[ i ] [ 1 ] + MSG_DBE_NOT_LOADED, { "OK" } )
      ENDIF
   NEXT i

   /*
   *   Erzeugen von Database-Engines
   */
   FOR i := 1 TO LEN( aBuild )
      IF !DbeBuild( aBuild[ i ] [ 1 ], aDbes[ aBuild[ i ] [ 2 ] ] [ 1 ], aDbes[ aBuild[ i ] [ 3 ] ] [ 1 ] )
         ALERT( aBuild[ i ] [ 1 ] + MSG_DBE_NOT_CREATED, { "OK" } )
      ENDIF
   NEXT i

RETURN

//
// EOF

*+ EOF: DbeSys.prg
