*+--------------------------------------------------------------------
*+
*+ Source Module => d:\ALASKA\6\\LUTZ.PRG
*+
*+    Copyright(C) 1983-2020 by Auge & Ohr
*+
*+    Functions: Procedure Child_Crt_1()
*+               Static Function CenterPos()
*+               Static Function monitor()
*+               Static Function RestoreFont()
*+               Static Procedure SetNewFont()
*+
*+    Reformatted by Click! 2.05.30 on Jun-8-2020 at  5:11 am
*+
*+--------------------------------------------------------------------

#include "Appevent.ch"
#include "Font.ch"
#include "Gra.ch"
#include "Xbp.ch"

#define DEF_ROWS  50
#define DEF_COLS  80

MEMVAR cStandard, cSignal, f_taste, f_wahl, c_browse, vSelect

*+--------------------------------------------------------------------
*+
*+    Procedure Child_Crt_1()
*+
*+    Called from ( lutzmain.prg )   1 - static procedure dialogmenu()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE Child_Crt_1( oParent, oCrt )

LOCAL oXbp, oRbMenu, aPos, aSize := { 600, 300 }
LOCAL aFont      := { "Arial", 14, 10, 25 }
LOCAL GetList    := {}
LOCAL promptList := {}

STATIC lRunning := .F.

PUBLIC cStandard, cSignal, f_taste, f_wahl, c_browse, vSelect

   IF lRunning = .T.
      msgbox( "is running ... " )
      RETURN
   ENDIF

   lRunning := .T.

   oCrt := XbpCrt() :new( oParent:DrawingArea,, { 0, 0 }, DEF_ROWS, DEF_COLS )
   oCrt:taskList := .T.
   //  oCrt:titlebar := .F.
   oCrt:title := "Normales XbpCrt-Fenster auf dem Desktop"
   oCrt:close := { | mp1, mp2, obj | obj:destroy() }
   oCrt:setDisplayFocus := { | uNIL1, uNIL2, self | SetAppWindow( self ) }
   oCrt:setInputFocus := { | uNIL1, uNIL2, self | SetAppFocus( self ) }

   oCrt:FontName := aFont[ 1 ]                                        // oFont:familyName
   oCrt:FontHeight := aFont[ 2 ]                                      // oFont:height
   oCrt:FontWidth := aFont[ 3 ]                                       // oFont:width
   //   oCrt:FontHeight := aFont[4]      // oFont:nominalPointSize
   oCrt:autoFocus := .T.
   oCrt:autoMark := .T.
   //   oCrt:setName( ID_CRT1 )

   oCrt:create()

   oRbMenu := XBPMENU() :new( oCrt ) :create()
   oRbMenu:title := "Popup"
   oRbMenu:AddItem( { "~Font", { || SetNewFont( oParent, oCrt ) } } )
   oRbMenu:AddItem( { NIL, NIL, XBPMENUBAR_MIS_SEPARATOR, 0 } )
   oRbMenu:addItem( { "~copy ", { || NACHCLP() } } )
   oRbMenu:addItem( { "~paste", { || VONCLP() } } )
   oRbMenu:AddItem( { NIL, NIL, XBPMENUBAR_MIS_SEPARATOR, 0 } )

   oCrt:rbClick := { | aPos, mp2, obj | oRbMenu:PopUp( obj, PopAbsPos( oParent ), 2, ;
                     XBPMENU_PU_DEFAULT + XBPMENU_PU_MOUSE_RBDOWN ) }

   SetAppWindow( oCrt )
   SETMODE( DEF_ROWS, DEF_COLS )
   SetAppFocus( oCrt )

   RestoreFont()
   Monitor()
   SetMouse( .t. )
   oCrt:mouseMode := XBPCRT_MOUSEMODE_VIO

   // resize Parent
   aSize := oCrt:CurrentSize()
   aSize[ 2 ] -= GetTitleBarHeight( oParent )
   oParent:clientSize := aSize
   CenterControl( oParent )

   // ****************** ab hier Console ***********************
   // CRT
   SETCOLOR( "W" )
   DO WHILE .T.
      CLEAR
      // m_42:=Maske("Neues Fenster")
      SET MESSAGE TO 22 CENTER
      @  8, 30 PROMPT "1 - Einzelwertung "
      @ 10, 30 PROMPT "2 - Team-Wertungen"
      @ 12, 30 PROMPT "3 - Online-Liga "
      @ 16, 30 PROMPT "X - Ende "
      MENU TO vSelect

      DO CASE
         CASE vSelect = 4
            DBCLOSEAREA()
            //  RETURN
            EXIT
      ENDCAS
   ENDDO
   CLS

   oXbp := XbpPushButton() :new( oCrt,, { 12, 12 }, { 84, 24 } )
   oXbp:caption := "Schlieen"
   oXbp:create()
   oXbp:activate := { || lRunning := .F., PostAppEvent( xbeP_Close,,, oCrt ) }
   SetAppFocus( oXbp )

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Function CenterPos()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION CenterPos( aSize, aRefSize )

RETURN { INT( ( aRefSize[ 1 ] - aSize[ 1 ] ) / 2 ) ;
         , INT( ( aRefSize[ 2 ] - aSize[ 2 ] ) / 2 ) }

*+--------------------------------------------------------------------
*+
*+    Static Function monitor()
*+
*+    Called from ( lutz.prg )   1 - procedure child_crt_1()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION monitor()

   SET CONFIRM ON
   SET DATE TO GERMAN
   SET DELETED ON
   SET CHARSET TO OEM

   cStandard := "W"
   cSignal := "/W"
   f_taste := "W"
   f_wahl := "/W"
   c_browse := "N/W,W/R,BG/W,W/BG,B/W,B/BG,W/GR,B/R"
   SETCOLOR( cStandard )
RETURN .T.

*+--------------------------------------------------------------------
*+
*+    Static Function RestoreFont()
*+
*+    Called from ( lutz.prg )   1 - procedure child_crt_1()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION RestoreFont()                                         // registry or INI-File

LOCAL lOK := .F.
RETURN lOK

*+--------------------------------------------------------------------
*+
*+    Static Procedure SetNewFont()
*+
*+    Called from ( lutz.prg )   1 - procedure child_crt_1()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE SetNewFont( oParent, oCrt )

LOCAL oFont, oFontDlg, aSize

   oFontDlg := XBPFONTDIALOG() :New()
   oFontDlg:fixedOnly := .T.
   oFontDlg:create()

   // auswhlen lassen
   oFont := oFontDlg:display( XBP_DISP_APPMODAL )
   IF NIL <> oFont

      oCrt:FontName := oFont:familyName
      oCrt:FontHeight := oFont:height
      oCrt:FontWidth := oFont:width
      oCrt:Configure()

      aSize := oCrt:CurrentSize()
      aSize[ 2 ] -= GetTitleBarHeight( oParent )

      oParent:clientSize := aSize
      oParent:DrawingArea:SetFont( oFont )
      CenterControl( oParent, APPDESKTOP() )

      // Aktuellen Fontnamen
      oFontDlg:familyName := oFont:familyName                         // registrieren
      oFontDlg:nominalPointSize := oFont:nominalPointSize

   ENDIF

   oFontDlg:destroy()                                                 // Font-Dialog freigeben

RETURN

// -------------

*+ EOF: LUTZ.PRG
